net.sf.saxon

## Class Filter

- java.lang.Object
- - net.sf.saxon.Filter

- All Implemented Interfaces:
    XMLFilter, XMLReader

      public class Filter
      extends Object
      implements XMLFilter

  Filter is an XMLFilter (a SAX2 filter) that performs a transformation taking a SAX stream as input and producing a SAX stream as output.
  Author:
    Michael H. Kay

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `Filter(Controller controller)` Create a Filter and initialise variables.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ContentHandler` | `getContentHandler()` Get the ContentHandler registered using setContentHandler()
    `DTDHandler` | `getDTDHandler()` Return the current DTD handler.
    `EntityResolver` | `getEntityResolver()` Return the current entity resolver.
    `ErrorHandler` | `getErrorHandler()` Return the current error handler.
    `boolean` | `getFeature(String name)` Look up the value of a feature.
    `XMLReader` | `getParent()` Get the parent reader.
    `Object` | `getProperty(String name)` Look up the value of a property.
    `Transformer` | `getTransformer()` Get the underlying Transformer.
    `void` | `parse(InputSource input)` Parse an XML document - In the context of a Transformer, this means perform a transformation.
    `void` | `parse(String systemId)` Parse (that is, transform) an XML document given a system identifier (URI).
    `void` | `setContentHandler(ContentHandler handler)` Register a content handler to receive the output of the transformation filter.
    `void` | `setDTDHandler(DTDHandler handler)` Allow an application to register a DTD event handler.
    `void` | `setEntityResolver(EntityResolver resolver)` Allow an application to register an entity resolver.
    `void` | `setErrorHandler(ErrorHandler handler)` Allow an application to register an error event handler.
    `void` | `setFeature(String name, boolean value)` Set the state of a feature.
    `void` | `setParent(XMLReader parent)` Set the parent reader.
    `void` | `setProperty(String name, Object value)` Set the value of a property.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Filter

          protected Filter(Controller controller)

      Create a Filter and initialise variables. The constructor is protected, because the Filter should be created using newXMLFilter() in the SAXTransformerFactory class

  - ### Method Detail

    - #### setParent

          public void setParent(XMLReader parent)

      Set the parent reader.

      This method allows the application to link the filter to a parent reader (which may be another filter). The argument may not be null.

      Specified by:
        `setParent` in interface `XMLFilter`
      Parameters:
        `parent` - The parent reader (the supplier of SAX events).

    - #### getParent

          public XMLReader getParent()

      Get the parent reader.

      This method allows the application to query the parent reader (which may be another filter). It is generally a bad idea to perform any operations on the parent reader directly: they should all pass through this filter.

      Specified by:
        `getParent` in interface `XMLFilter`
      Returns:
        The parent filter, or null if none has been set.

    - #### getFeature

          public boolean getFeature(String name)
                             throws SAXNotRecognizedException,
                                    SAXNotSupportedException

      Look up the value of a feature.

      The feature name is any fully-qualified URI. It is possible for an XMLReader to recognize a feature name but to be unable to return its value; this is especially true in the case of an adapter for a SAX1 Parser, which has no way of knowing whether the underlying parser is performing validation or expanding external entities.

      All XMLReaders are required to recognize the http://xml.org/sax/features/namespaces and the http://xml.org/sax/features/namespace-prefixes feature names.

      Specified by:
        `getFeature` in interface `XMLReader`
      Parameters:
        `name` - The feature name, which is a fully-qualified URI.
      Returns:
        The current state of the feature (true or false).
      Throws:
        `SAXNotRecognizedException` - When the XMLReader does not recognize the feature name.
        `SAXNotSupportedException` - When the XMLReader recognizes the feature name but cannot determine its value at this time.
      See Also:
        `setFeature(java.lang.String, boolean)`

    - #### setFeature

          public void setFeature(String name,
                        boolean value)
                          throws SAXNotRecognizedException,
                                 SAXNotSupportedException

      Set the state of a feature.

      The feature name is any fully-qualified URI. It is possible for an XMLReader to recognize a feature name but to be unable to set its value

      All XMLReaders are required to support setting http://xml.org/sax/features/namespaces to true and http://xml.org/sax/features/namespace-prefixes to false.

      Some feature values may be immutable or mutable only in specific contexts, such as before, during, or after a parse.

      Specified by:
        `setFeature` in interface `XMLReader`
      Parameters:
        `name` - The feature name, which is a fully-qualified URI.
        `value` - The requested state of the feature (true or false).
      Throws:
        `SAXNotRecognizedException` - When the XMLReader does not recognize the feature name.
        `SAXNotSupportedException` - When the XMLReader recognizes the feature name but cannot set the requested value.
      See Also:
        `getFeature(java.lang.String)`

    - #### getProperty

          public Object getProperty(String name)
                             throws SAXNotRecognizedException,
                                    SAXNotSupportedException

      Look up the value of a property.

      The property name is any fully-qualified URI. It is possible for an XMLReader to recognize a property name but to be unable to return its state.

      XMLReaders are not required to recognize any specific property names, though an initial core set is documented for SAX2.

      Some property values may be available only in specific contexts, such as before, during, or after a parse.

      Implementors are free (and encouraged) to invent their own properties, using names built on their own URIs.

      Specified by:
        `getProperty` in interface `XMLReader`
      Parameters:
        `name` - The property name, which is a fully-qualified URI.
      Returns:
        The current value of the property.
      Throws:
        `SAXNotRecognizedException` - When the XMLReader does not recognize the property name.
        `SAXNotSupportedException` - When the XMLReader recognizes the property name but cannot determine its value at this time.
      See Also:
        `setProperty(java.lang.String, java.lang.Object)`

    - #### setProperty

          public void setProperty(String name,
                         Object value)
                           throws SAXNotRecognizedException,
                                  SAXNotSupportedException

      Set the value of a property.

      The property name is any fully-qualified URI. It is possible for an XMLReader to recognize a property name but to be unable to set its value.

      XMLReaders are not required to recognize setting any specific property names, though a core set is provided with SAX2.

      Some property values may be immutable or mutable only in specific contexts, such as before, during, or after a parse.

      This method is also the standard mechanism for setting extended handlers.

      Specified by:
        `setProperty` in interface `XMLReader`
      Parameters:
        `name` - The property name, which is a fully-qualified URI.
        `value` - The requested value for the property.
      Throws:
        `SAXNotRecognizedException` - When the XMLReader does not recognize the property name.
        `SAXNotSupportedException` - When the XMLReader recognizes the property name but cannot set the requested value.

    - #### setContentHandler

          public void setContentHandler(ContentHandler handler)

      Register a content handler to receive the output of the transformation filter. If the content handler is also a LexicalHandler, and if no LexicalHandler is separately registered, the ContentHandler will also act as the LexicalHandler
      Specified by:
        `setContentHandler` in interface `XMLReader`

    - #### getContentHandler

          public ContentHandler getContentHandler()

      Get the ContentHandler registered using setContentHandler()
      Specified by:
        `getContentHandler` in interface `XMLReader`

    - #### setEntityResolver

          public void setEntityResolver(EntityResolver resolver)

      Allow an application to register an entity resolver.

      If the application does not register an entity resolver, the XMLReader will perform its own default resolution.

      Applications may register a new or different resolver in the middle of a parse, and the SAX parser must begin using the new resolver immediately.

      Specified by:
        `setEntityResolver` in interface `XMLReader`
      Parameters:
        `resolver` - The entity resolver.
      Throws:
        `NullPointerException` - If the resolver argument is null.
      See Also:
        `getEntityResolver()`

    - #### getEntityResolver

          public EntityResolver getEntityResolver()

      Return the current entity resolver.
      Specified by:
        `getEntityResolver` in interface `XMLReader`
      Returns:
        Always null, since no entity resolver is used even if one is supplied.
      See Also:
        `setEntityResolver(org.xml.sax.EntityResolver)`

    - #### setDTDHandler

          public void setDTDHandler(DTDHandler handler)

      Allow an application to register a DTD event handler.

      If the application does not register a DTD handler, all DTD events reported by the SAX parser will be silently ignored.

      Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

      Specified by:
        `setDTDHandler` in interface `XMLReader`
      Parameters:
        `handler` - The DTD handler.
      Throws:
        `NullPointerException` - If the handler argument is null.
      See Also:
        `getDTDHandler()`

    - #### getDTDHandler

          public DTDHandler getDTDHandler()

      Return the current DTD handler.
      Specified by:
        `getDTDHandler` in interface `XMLReader`
      Returns:
        Always null, since no DTD handler is used even if one has been supplied.
      See Also:
        `setDTDHandler(org.xml.sax.DTDHandler)`

    - #### setErrorHandler

          public void setErrorHandler(ErrorHandler handler)

      Allow an application to register an error event handler.

      If the application does not register an error handler, all error events reported by the SAX parser will be silently ignored; however, normal processing may not continue. It is highly recommended that all SAX applications implement an error handler to avoid unexpected bugs.

      Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

      Specified by:
        `setErrorHandler` in interface `XMLReader`
      Parameters:
        `handler` - The error handler.
      Throws:
        `NullPointerException` - If the handler argument is null.
      See Also:
        `getErrorHandler()`

    - #### getErrorHandler

          public ErrorHandler getErrorHandler()

      Return the current error handler.
      Specified by:
        `getErrorHandler` in interface `XMLReader`
      Returns:
        The current error handler, or null if none has been registered.
      See Also:
        `setErrorHandler(org.xml.sax.ErrorHandler)`

    - #### parse

          public void parse(InputSource input)
                     throws IOException,
                            SAXException

      Parse an XML document - In the context of a Transformer, this means perform a transformation. The method is equivalent to transform().
      Specified by:
        `parse` in interface `XMLReader`
      Parameters:
        `input` - The input source (the XML document to be transformed)
      Throws:
        `SAXException` - Any SAX exception, possibly wrapping another exception.
        `IOException` - An IO exception from the parser, possibly from a byte stream or character stream supplied by the application.
      See Also:
        `InputSource`, `parse(java.lang.String)`, `setEntityResolver(org.xml.sax.EntityResolver)`, `setDTDHandler(org.xml.sax.DTDHandler)`, `setContentHandler(org.xml.sax.ContentHandler)`, `setErrorHandler(org.xml.sax.ErrorHandler)`

    - #### parse

          public void parse(String systemId)
                     throws IOException,
                            SAXException

      Parse (that is, transform) an XML document given a system identifier (URI).

      This method is a shortcut for the common case of reading a document from a system identifier. It is the exact equivalent of the following:

           parse(new InputSource(systemId));

      If the system identifier is a URL, it must be fully resolved by the application before it is passed to the parser.

      Specified by:
        `parse` in interface `XMLReader`
      Parameters:
        `systemId` - The system identifier (URI).
      Throws:
        `SAXException` - Any SAX exception, possibly wrapping another exception.
        `IOException` - An IO exception from the parser, possibly from a byte stream or character stream supplied by the application.
      See Also:
        `parse(org.xml.sax.InputSource)`

    - #### getTransformer

          public Transformer getTransformer()

      Get the underlying Transformer. This is a Saxon-specific method that allows the user to set parameters on the transformation, set a URIResolver or ErrorListener, etc. New in Saxon 7.2

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.